; TRAINER BY CIRTI FOR QUARTIX
; ONLY FOR QUARTIX MEMBERS !!!!!!

ORG $20000
LOAD $20000

RUN:
	MOVEM.L D0-D7/A0-A6,-(SP)

	LEA	$60000,A0	; ERASE MEM
	MOVE.W	#$4800,D0
ERASE1:	MOVE.W	#0,(A0)+
DBRA	D0,ERASE1
;----------------------------------------------------------------
BT1=$62000
	CMP.W	#1,PASSE_ONE
	BEQ	NO_TRANS
	BSR	TRANSTEXT
NO_TRANS:
	LEA	BT1,A3
	LEA	TEXTE,A0
	BSR	CONS_SCREEN

	LEA	P1,A0
	MOVE.L	#PIC+[0*10240],D0
	MOVE.W	D0,6(A0)
	SWAP	D0
	MOVE.W	D0,2(A0)
	LEA	P2,A0
	MOVE.L	#PIC+[1*10240],D0
	MOVE.W	D0,6(A0)
	SWAP	D0
	MOVE.W	D0,2(A0)
	LEA	P3,A0
	MOVE.L	#PIC+[2*10240],D0
	MOVE.W	D0,6(A0)
	SWAP	D0
	MOVE.W	D0,2(A0)
	LEA	P4,A0
	MOVE.L	#PIC+[3*10240],D0
	MOVE.W	D0,6(A0)
	SWAP	D0
	MOVE.W	D0,2(A0)
	LEA	P5,A0
	MOVE.L	#PIC+[4*10240],D0
	MOVE.W	D0,6(A0)
	SWAP	D0
	MOVE.W	D0,2(A0)

	BSR.L SAVE_ALL

	LEA $DFF000,A6
	MOVE #$3FFF,$9A(A6)
	MOVE #$C010,$9A(A6)
	MOVE #$3FFF,$96(A6)
	MOVE #$87E0,$96(A6)
	MOVE.L #IRQ,$6C

	MOVE.L #%111101111011100111101111,$60000+38
	MOVE.L #%100000110010100011000110,$60000+44+38
	MOVE.L #%100000110011100011000110,$60000+88+38
	MOVE.L #%100000110010010011000110,$60000+132+38
	MOVE.L #%111101111010010011001111,$60000+176+38
	CLR.L	$60000

	BRA	SUITE
PUTON:
	MOVE.L	#BT1+[8*9*40]+32-80,A3
	ADD.L D0,A3

	LEA	ON,A0
	BSR	CONS_SCREEN
RTS

PUTOFF:
	MOVE.L	#BT1+[8*9*40]+32-80,A3
	ADD.L D0,A3

	LEA	OFF,A0
	BSR	CONS_SCREEN
RTS

SUITE:
	JSR MT_INIT

	LEA $DFF000,A6
	MOVE.L #$3C791CC9,$8E(A6)
	MOVE.L #$3000D8,$92(A6)
	MOVE.L #COPPERLIST1,$80(A6)
	CLR $88(A6)

BSR	ATT
BSR	ATT
BSR	ATT
BSR	ATT

	MOVE.W	#1,FOND1
BSR	ATT
BSR	ATT

FIRST_WAIT:
	BTST #6,$BFE001
	BNE.S FIRST_WAIT

	MOVE.W	#1,FOND2

BSR	ATT
WAIT:
	TST FLAG1
	BNE WAIT1

	MOVE #1,FLAG1
WAIT1:
	BTST #6,$BFE001
	BNE.S WAIT
WB:BTST #$E,2(A6)
	BNE.S WB
BSR.L RESTORE_ALL
	BSR	COPIE
	JSR MT_END
	MOVEM.L (SP)+,D0-D7/A0-A6
	RTS

FOND1:DC.W	0
FOND2:DC.W	0
FLAG:DC.W -1
FLAG1:DC.W 0

ATT:
	MOVE.W	#50,D1
	MOVE.W	#$F000,D0
BOUCLE_ATTENTE:
	MULU	#60,D1
	MULU	#60,D1
	MULU	#60,D1
	MULU	#60,D1
	DBRA	D0,BOUCLE_ATTENTE
RTS

IRQ:
	MOVEM.L D0-D7/A0-A6,-(A7)
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	IRQ4		

	BSR	TOUCHE

	CMP.W	#1,FOND1
	BNE	NO_FOND1
	BSR	MAKE_FONDU_2
NO_FOND1:
	CMP.W	#1,FOND2
	BNE	NO_FOND2
	BSR	MAKE_FONDU_1
NO_FOND2:
	CMP.W	#2,FOND2
	BNE	NO_FOND3
	MOVE.L #COPPERLIST,$80(A6)
	CLR $88(A6)
	CLR.W	FOND1
	CLR.W	FOND2
NO_FOND3:
	JSR	MT_MUSIC

IRQ4:
	MOVE #$10,$9C(A6)
	MOVEM.L (A7)+,D0-D7/A0-A6
RTE


TOUCHE:
	BTST #3,$BFED01
	BEQ TOUCHE5
	MOVE.B $BFEC01,D0
	BSET #6,$BFEE01
	NOT.B D0
	ROR.B #1,D0
	MOVEQ #$32,D7
TOUCHETEMPO:
	DBRA D7,TOUCHETEMPO

	BCLR #6,$BFEE01
	CMPI.B #$50,D0
	BEQ F1
	CMPI.B #$51,D0
	BEQ F2
TOUCHE5:
	RTS

ETAT1:DC.B 0	;OFF
ETAT2:DC.B 0

F1:
	CLR.L D0
	LEA ETAT1,A0
	BCHG #0,(A0)
	BRA CHANGE
F2:
	MOVE.L #[10*40],D0
	LEA ETAT2,A0
	BCHG #0,(A0)
	BRA CHANGE

CHANGE:
	BTST #0,(A0)
	BEQ TOFF
	BRA PUTON
TOFF:
	BRA PUTOFF
;---------------------------------------------------------------
;---------------------------------------------------------------
COPIE:
	LEA	ETAT1,A0
	MOVE.W	(A0),$7C010
	LEA	PL1,A0
	LEA	$7C012,A1

COP:
	CMP.L	#$FFFFFFFF,(A0)
	BEQ	END_T
	MOVE.L	(A0)+,(A1)+
	BRA	COP

END_T:	RTS

PL1:	CMP.B	#1,$7C010
	BEQ	PAS_PL1
	SUBQ.W	#1,$29232
PAS_PL1:BRA	FIN_TRAINER
	CMP.B	#1,$7C011
	BEQ	PAS_PL2
	SUBQ.W	#1,$29290
PAS_PL2:	
FIN_TRAINER:
RTS
DC.L	$FFFFFFFF
;---------------------------------------------------------------
;---------------------------------------------------------------
COMPTTEXT1:DC.W	-1

CONS_SCREEN:
	MOVE.W	#39,D4
BOUCLE1:
	ADD.W	#1,COMPTTEXT1
	MOVE.W	COMPTTEXT1,D0
	CLR.W	D1
	MOVE.B	(A0,D0.W),D1
	CMP.B	#$FF,D1
	BNE	CONT1
	MOVE.W	#-1,COMPTTEXT1
	BRA	FIN_FIN
CONT1:
	LEA	ADDRESSE,A4
	MULU	#2,D1

	MOVE.W	(A4,D1.W),ABS		; ABS=ADDRRESSE DANS LA FONTE

	LEA	FONT,A2
	ADD.W	ABS,A2

	MOVE.L	A3,A5
	MOVE.W	#7,D0
BOUCLE:
	MOVE.B	(A2)+,(A5)
	ADD.L	#40,A5
	DBRA	D0,BOUCLE

	ADD.L	#1,A3
DBRA	D4,BOUCLE1
	ADD.L	#40*9,A3
BRA	CONS_SCREEN

FIN_FIN:
RTS
;---------------------------------------------------------------
ABS:DC.W	0
;---------------------------------------------------------------
TRANSTEXT:
	CLR.L 	D0
	LEA 	CODETABLE,A0
	LEA	TEXTE,A1
	BSR	DO_TRANS

	CLR.L 	D0
	LEA 	CODETABLE,A0
	LEA	ON,A1
	BSR	DO_TRANS

	CLR.L 	D0
	LEA 	CODETABLE,A0
	LEA	OFF,A1
	BSR	DO_TRANS

	MOVE.W	#1,PASSE_ONE
RTS
;---------------------------------------------------------------
DO_TRANS:
TT1:
	CLR.L	D1
	MOVE.B	(A1),D1
	MOVE.B 	(A0),D0
	CMP.B 	(A1),D0
	BNE 	TT2
	MOVE.B 	1(A0),(A1)
TT3:
	CMP.B 	#255,(A1)
	BEQ 	ENDTT
	LEA 	CODETABLE,A0
	ADD 	#1,A1
	BRA 	TT1
TT2:
	ADD 	#2,A0
	BRA TT1
ENDTT:
RTS
;---------------------------------------------------------------
PASSE_ONE:DC.W	0	; DEJA CONVERTI TEXT =1
;----------------------------------------------------------------
TEXTE:	       ;"                                        "
	DC.B	"                                        "
	DC.B	"        THE VERY BEST QUARTIX           "
	DC.B	"                                        "
	DC.B	"               PRESENTS                 "
	DC.B	"                                        "
	DC.B	"         MEGAPHOENIX TRAINER            "
	DC.B	"                                        "
	DC.B	"      F1 - UNLIMITED LIVES P1   OFF     "
	DC.B	"      F2 - UNLIMITED LIVES P2   OFF     "
	DC.B	"                                        "
	DC.B	"      CRACKED BY DJ OF SKILLION.        "
	DC.B	"      THIS GAME WAS TRAINED BY :        "
	DC.B	"          MANKICK /QUARTIX AND          "
	DC.B	"           TOXIN  /QUARTIX              "
	DC.B	"                                        "
	DC.B	"      INTRO CODED BY  CIRTI             "
	DC.B	"            GIFIX BY  MICK              "
	DC.B	"       GOOD MUSIC BY  MIBY  ...         "
	DC.B	"                                        "
	DC.B	"  PRESS LEFT MOUSEBUTTON TO START GAME  "
	DC.B	"                                        "
	DC.B	$FF,$FF,$FF,$FF
EVEN
ON:	DC.B	"ON ",$FF,$FF,$FF
EVEN
OFF:	DC.B	"OFF",$FF,$FF,$FF
EVEN
;----------------------------------------------------------------
CODETABLE:
DC.B "A",0,"B",1,"C",2,"D",3,"E",4,"F",5,"G",6,"H",7,"I",8
DC.B "J",9,"K",10,"L",11,"M",12,"N",13,"O",14,"P",15,"Q",16
DC.B "R",17,"S",18,"T",19,"U",20,"V",21,"W",22,"X",23,"Y",24,"Z",25
DC.B "A",0,"B",1,"C",2,"D",3,"E",4,"F",5,"G",6,"H",7,"I",8
DC.B "J",9,"K",10,"L",11,"M",12,"N",13,"O",14,"P",15,"Q",16
DC.B "R",17,"S",18,"T",19,"U",20,"V",21,"W",22,"X",23,"Y",24,"Z",25

dc.b "a",0,"b",1,"c",2,"d",3,"e",4,"f",5,"g",6,"h",7,"i",8
dc.b "j",9,"k",10,"l",11,"m",12,"n",13,"o",14,"p",15,"q",16
dc.b "r",17,"s",18,"t",19,"u",20,"v",21,"w",22,"x",23,"y",24,"z",25
dc.b "a",0,"b",1,"c",2,"d",3,"e",4,"f",5,"g",6,"h",7,"i",8
dc.b "j",9,"k",10,"l",11,"m",12,"n",13,"o",14,"p",15,"q",16
dc.b "r",17,"s",18,"t",19,"u",20,"v",21,"w",22,"x",23,"y",24,"z",25

DC.B "0",26,"1",27,"2",28,"3",29,"4",30,"5",31,"6",32,"7",33,"8",34
DC.B "9",35,",",36,"'",37,".",38,":",39,"(",40,")",41,"[",42,"]",43
DC.B "?",44,"!",45,"/",46,"-",47," ",48,"*",49

DC.B 255,255
EVEN
ADDRESSE:
	DC.W	264,272,280,288,296,304,312,320,328,336,344,352,360
	DC.W	368,376,384,392,400,408,416,424,432,440,448,456,464
	DC.W	128,136,144,152,160,168,176,184,192,200
	DC.W	96,56,112,208,224,240,472,488,248,8,120,104,0,760

EVEN


RTS
;---------------------------------------------------------------
;---------------------------------------------------------------
;
;   NoisetrackerV1.0 replayroutine   
; Mahoney & Kaktus - HALLONSOFT 1989 
;

MT_INIT:LEA	MT_DATA,A0
	MOVE.L	A0,A1
	ADD.L	#$3B8,A1
	MOVEQ	#$7F,D0
	MOVEQ	#0,D1
MT_LOOP:MOVE.L	D1,D2
	SUBQ.W	#1,D0
MT_LOP2:MOVE.B	(A1)+,D1
	CMP.B	D2,D1
	BGT.S	MT_LOOP
	DBF	D0,MT_LOP2
	ADDQ.B	#1,D2

	LEA	MT_SAMPLESTARTS(PC),A1
	ASL.L	#8,D2
	ASL.L	#2,D2
	ADD.L	#$43C,D2
	ADD.L	A0,D2
	MOVE.L	D2,A2
	MOVEQ	#$1E,D0
MT_LOP3:CLR.L	(A2)
	MOVE.L	A2,(A1)+
	MOVEQ	#0,D1
	MOVE.W	42(A0),D1
	ASL.L	#1,D1
	ADD.L	D1,A2
	ADD.L	#$1E,A0
	DBF	D0,MT_LOP3

	OR.B	#$2,$BFE001
	MOVE.B	#$6,MT_SPEED
	CLR.W	$DFF0A8
	CLR.W	$DFF0B8
	CLR.W	$DFF0C8
	CLR.W	$DFF0D8
	CLR.B	MT_SONGPOS
	CLR.B	MT_COUNTER
	CLR.W	MT_PATTPOS
	RTS

MT_END:	CLR.W	$DFF0A8
	CLR.W	$DFF0B8
	CLR.W	$DFF0C8
	CLR.W	$DFF0D8
	MOVE.W	#$F,$DFF096
	RTS

MT_MUSIC:
	MOVEM.L	D0-D4/A0-A3/A5-A6,-(A7)
	LEA	MT_DATA,A0
	ADDQ.B	#$1,MT_COUNTER
	MOVE.B	MT_COUNTER,D0
	CMP.B	MT_SPEED,D0
	BLT.S	MT_NONEW
	CLR.B	MT_COUNTER
	BRA	MT_GETNEW

MT_NONEW:
	LEA	MT_VOICE1(PC),A6
	LEA	$DFF0A0,A5
	BSR	MT_CHECKCOM
	LEA	MT_VOICE2(PC),A6
	LEA	$DFF0B0,A5
	BSR	MT_CHECKCOM
	LEA	MT_VOICE3(PC),A6
	LEA	$DFF0C0,A5
	BSR	MT_CHECKCOM
	LEA	MT_VOICE4(PC),A6
	LEA	$DFF0D0,A5
	BSR	MT_CHECKCOM
	BRA	MT_ENDR

MT_ARPEGGIO:
	MOVEQ	#0,D0
	MOVE.B	MT_COUNTER,D0
	DIVS	#$3,D0
	SWAP	D0
	CMP.W	#$0,D0
	BEQ.S	MT_ARP2
	CMP.W	#$2,D0
	BEQ.S	MT_ARP1

	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	LSR.B	#4,D0
	BRA.S	MT_ARP3
MT_ARP1:MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	AND.B	#$F,D0
	BRA.S	MT_ARP3
MT_ARP2:MOVE.W	$10(A6),D2
	BRA.S	MT_ARP4
MT_ARP3:ASL.W	#1,D0
	MOVEQ	#0,D1
	MOVE.W	$10(A6),D1
	LEA	MT_PERIODS(PC),A0
	MOVEQ	#$24,D7
MT_ARPLOOP:
	MOVE.W	(A0,D0.W),D2
	CMP.W	(A0),D1
	BGE.S	MT_ARP4
	ADDQ.L	#2,A0
	DBF	D7,MT_ARPLOOP
	RTS
MT_ARP4:MOVE.W	D2,$6(A5)
	RTS

MT_GETNEW:
	LEA	MT_DATA,A0
	MOVE.L	A0,A3
	MOVE.L	A0,A2
	ADD.L	#$C,A3
	ADD.L	#$3B8,A2
	ADD.L	#$43C,A0

	MOVEQ	#0,D0
	MOVE.L	D0,D1
	MOVE.B	MT_SONGPOS,D0
	MOVE.B	(A2,D0.W),D1
	ASL.L	#8,D1
	ASL.L	#2,D1
	ADD.W	MT_PATTPOS,D1
	CLR.W	MT_DMACON

	LEA	$DFF0A0,A5
	LEA	MT_VOICE1(PC),A6
	BSR.S	MT_PLAYVOICE
	LEA	$DFF0B0,A5
	LEA	MT_VOICE2(PC),A6
	BSR.S	MT_PLAYVOICE
	LEA	$DFF0C0,A5
	LEA	MT_VOICE3(PC),A6
	BSR.S	MT_PLAYVOICE
	LEA	$DFF0D0,A5
	LEA	MT_VOICE4(PC),A6
	BSR.S	MT_PLAYVOICE
	BRA	MT_SETDMA

MT_PLAYVOICE:
	MOVE.L	(A0,D1.L),(A6)
	ADDQ.L	#4,D1
	MOVEQ	#0,D2
	MOVE.B	$2(A6),D2
	AND.B	#$F0,D2
	LSR.B	#4,D2
	MOVE.B	(A6),D0
	AND.B	#$F0,D0
	OR.B	D0,D2
	TST.B	D2
	BEQ.S	MT_SETREGS
	MOVEQ	#0,D3
	LEA	MT_SAMPLESTARTS(PC),A1
	MOVE.L	D2,D4
	SUBQ.L	#$1,D2
	ASL.L	#2,D2
	MULU	#$1E,D4
	MOVE.L	(A1,D2.L),$4(A6)
	MOVE.W	(A3,D4.L),$8(A6)
	MOVE.W	$2(A3,D4.L),$12(A6)
	MOVE.W	$4(A3,D4.L),D3
	TST.W	D3
	BEQ.S	MT_NOLOOP
	MOVE.L	$4(A6),D2
	ASL.W	#1,D3
	ADD.L	D3,D2
	MOVE.L	D2,$A(A6)
	MOVE.W	$4(A3,D4.L),D0
	ADD.W	$6(A3,D4.L),D0
	MOVE.W	D0,8(A6)
	MOVE.W	$6(A3,D4.L),$E(A6)
	MOVE.W	$12(A6),$8(A5)
	BRA.S	MT_SETREGS
MT_NOLOOP:
	MOVE.L	$4(A6),D2
	ADD.L	D3,D2
	MOVE.L	D2,$A(A6)
	MOVE.W	$6(A3,D4.L),$E(A6)
	MOVE.W	$12(A6),$8(A5)
MT_SETREGS:
	MOVE.W	(A6),D0
	AND.W	#$FFF,D0
	BEQ	MT_CHECKCOM2
	MOVE.B	$2(A6),D0
	AND.B	#$F,D0
	CMP.B	#$3,D0
	BNE.S	MT_SETPERIOD
	BSR	MT_SETMYPORT
	BRA	MT_CHECKCOM2
MT_SETPERIOD:
	MOVE.W	(A6),$10(A6)
	AND.W	#$FFF,$10(A6)
	MOVE.W	$14(A6),D0
	MOVE.W	D0,$DFF096
	CLR.B	$1B(A6)

	MOVE.L	$4(A6),(A5)
	MOVE.W	$8(A6),$4(A5)
	MOVE.W	$10(A6),D0
	AND.W	#$FFF,D0
	MOVE.W	D0,$6(A5)
	MOVE.W	$14(A6),D0
	OR.W	D0,MT_DMACON
	BRA	MT_CHECKCOM2

MT_SETDMA:
	MOVE.W	#$12C,D0
MT_WAIT:DBF	D0,MT_WAIT
	MOVE.W	MT_DMACON,D0
	OR.W	#$8000,D0
	MOVE.W	D0,$DFF096
	MOVE.W	#$12C,D0
MT_WAI2:DBF	D0,MT_WAI2
	LEA	$DFF000,A5
	LEA	MT_VOICE4(PC),A6
	MOVE.L	$A(A6),$D0(A5)
	MOVE.W	$E(A6),$D4(A5)
	LEA	MT_VOICE3(PC),A6
	MOVE.L	$A(A6),$C0(A5)
	MOVE.W	$E(A6),$C4(A5)
	LEA	MT_VOICE2(PC),A6
	MOVE.L	$A(A6),$B0(A5)
	MOVE.W	$E(A6),$B4(A5)
	LEA	MT_VOICE1(PC),A6
	MOVE.L	$A(A6),$A0(A5)
	MOVE.W	$E(A6),$A4(A5)

	ADD.W	#$10,MT_PATTPOS
	CMP.W	#$400,MT_PATTPOS
	BNE.S	MT_ENDR
MT_NEX:	CLR.W	MT_PATTPOS
	CLR.B	MT_BREAK
	ADDQ.B	#1,MT_SONGPOS
	AND.B	#$7F,MT_SONGPOS
	MOVE.B	MT_SONGPOS,D1
	CMP.B	MT_DATA+$3B6,D1
	BNE.S	MT_ENDR
	MOVE.B	MT_DATA+$3B7,MT_SONGPOS
MT_ENDR:TST.B	MT_BREAK
	BNE.S	MT_NEX
	MOVEM.L	(A7)+,D0-D4/A0-A3/A5-A6
	RTS

MT_SETMYPORT:
	MOVE.W	(A6),D2
	AND.W	#$FFF,D2
	MOVE.W	D2,$18(A6)
	MOVE.W	$10(A6),D0
	CLR.B	$16(A6)
	CMP.W	D0,D2
	BEQ.S	MT_CLRPORT
	BGE.S	MT_RT
	MOVE.B	#$1,$16(A6)
	RTS
MT_CLRPORT:
	CLR.W	$18(A6)
MT_RT:	RTS

MT_MYPORT:
	MOVE.B	$3(A6),D0
	BEQ.S	MT_MYSLIDE
	MOVE.B	D0,$17(A6)
	CLR.B	$3(A6)
MT_MYSLIDE:
	TST.W	$18(A6)
	BEQ.S	MT_RT
	MOVEQ	#0,D0
	MOVE.B	$17(A6),D0
	TST.B	$16(A6)
	BNE.S	MT_MYSUB
	ADD.W	D0,$10(A6)
	MOVE.W	$18(A6),D0
	CMP.W	$10(A6),D0
	BGT.S	MT_MYOK
	MOVE.W	$18(A6),$10(A6)
	CLR.W	$18(A6)
MT_MYOK:MOVE.W	$10(A6),$6(A5)
	RTS
MT_MYSUB:
	SUB.W	D0,$10(A6)
	MOVE.W	$18(A6),D0
	CMP.W	$10(A6),D0
	BLT.S	MT_MYOK
	MOVE.W	$18(A6),$10(A6)
	CLR.W	$18(A6)
	MOVE.W	$10(A6),$6(A5)
	RTS

MT_VIB:	MOVE.B	$3(A6),D0
	BEQ.S	MT_VI
	MOVE.B	D0,$1A(A6)

MT_VI:	MOVE.B	$1B(A6),D0
	LEA	MT_SIN(PC),A4
	LSR.W	#$2,D0
	AND.W	#$1F,D0
	MOVEQ	#0,D2
	MOVE.B	(A4,D0.W),D2
	MOVE.B	$1A(A6),D0
	AND.W	#$F,D0
	MULU	D0,D2
	LSR.W	#$6,D2
	MOVE.W	$10(A6),D0
	TST.B	$1B(A6)
	BMI.S	MT_VIBMIN
	ADD.W	D2,D0
	BRA.S	MT_VIB2
MT_VIBMIN:
	SUB.W	D2,D0
MT_VIB2:MOVE.W	D0,$6(A5)
	MOVE.B	$1A(A6),D0
	LSR.W	#$2,D0
	AND.W	#$3C,D0
	ADD.B	D0,$1B(A6)
	RTS

MT_NOP:	MOVE.W	$10(A6),$6(A5)
	RTS

MT_CHECKCOM:
	MOVE.W	$2(A6),D0
	AND.W	#$FFF,D0
	BEQ.S	MT_NOP
	MOVE.B	$2(A6),D0
	AND.B	#$F,D0
	TST.B	D0
	BEQ	MT_ARPEGGIO
	CMP.B	#$1,D0
	BEQ.S	MT_PORTUP
	CMP.B	#$2,D0
	BEQ	MT_PORTDOWN
	CMP.B	#$3,D0
	BEQ	MT_MYPORT
	CMP.B	#$4,D0
	BEQ	MT_VIB
	MOVE.W	$10(A6),$6(A5)
	CMP.B	#$A,D0
	BEQ.S	MT_VOLSLIDE
	RTS

MT_VOLSLIDE:
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	LSR.B	#4,D0
	TST.B	D0
	BEQ.S	MT_VOLDOWN
	ADD.W	D0,$12(A6)
	CMP.W	#$40,$12(A6)
	BMI.S	MT_VOL2
	MOVE.W	#$40,$12(A6)
MT_VOL2:MOVE.W	$12(A6),$8(A5)
	RTS

MT_VOLDOWN:
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	AND.B	#$F,D0
	SUB.W	D0,$12(A6)
	BPL.S	MT_VOL3
	CLR.W	$12(A6)
MT_VOL3:MOVE.W	$12(A6),$8(A5)
	RTS

MT_PORTUP:
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	SUB.W	D0,$10(A6)
	MOVE.W	$10(A6),D0
	AND.W	#$FFF,D0
	CMP.W	#$71,D0
	BPL.S	MT_POR2
	AND.W	#$F000,$10(A6)
	OR.W	#$71,$10(A6)
MT_POR2:MOVE.W	$10(A6),D0
	AND.W	#$FFF,D0
	MOVE.W	D0,$6(A5)
	RTS

MT_PORTDOWN:
	CLR.W	D0
	MOVE.B	$3(A6),D0
	ADD.W	D0,$10(A6)
	MOVE.W	$10(A6),D0
	AND.W	#$FFF,D0
	CMP.W	#$358,D0
	BMI.S	MT_POR3
	AND.W	#$F000,$10(A6)
	OR.W	#$358,$10(A6)
MT_POR3:MOVE.W	$10(A6),D0
	AND.W	#$FFF,D0
	MOVE.W	D0,$6(A5)
	RTS

MT_CHECKCOM2:
	MOVE.B	$2(A6),D0
	AND.B	#$F,D0
	CMP.B	#$E,D0
	BEQ.S	MT_SETFILT
	CMP.B	#$D,D0
	BEQ.S	MT_PATTBREAK
	CMP.B	#$B,D0
	BEQ.S	MT_POSJMP
	CMP.B	#$C,D0
	BEQ.S	MT_SETVOL
	CMP.B	#$F,D0
	BEQ.S	MT_SETSPEED
	RTS

MT_SETFILT:
	MOVE.B	$3(A6),D0
	AND.B	#$1,D0
	ASL.B	#$1,D0
	AND.B	#$FD,$BFE001
	OR.B	D0,$BFE001
	RTS
MT_PATTBREAK:
	NOT.B	MT_BREAK
	RTS
MT_POSJMP:
	MOVE.B	$3(A6),D0
	SUBQ.B	#$1,D0
	MOVE.B	D0,MT_SONGPOS
	NOT.B	MT_BREAK
	RTS
MT_SETVOL:
	CMP.B	#$40,$3(A6)
	BLE.S	MT_VOL4
	MOVE.B	#$40,$3(A6)
MT_VOL4:MOVE.B	$3(A6),$8(A5)
	RTS
MT_SETSPEED:
	CMP.B	#$1F,$3(A6)
	BLE.S	MT_SETS
	MOVE.B	#$1F,$3(A6)
MT_SETS:MOVE.B	$3(A6),D0
	BEQ.S	MT_RTS2
	MOVE.B	D0,MT_SPEED
	CLR.B	MT_COUNTER
MT_RTS2:RTS

MT_SIN:
DC.B $00,$18,$31,$4A,$61,$78,$8D,$A1,$B4,$C5,$D4,$E0,$EB,$F4,$FA,$FD
DC.B $FF,$FD,$FA,$F4,$EB,$E0,$D4,$C5,$B4,$A1,$8D,$78,$61,$4A,$31,$18

MT_PERIODS:
DC.W $0358,$0328,$02FA,$02D0,$02A6,$0280,$025C,$023A,$021A,$01FC,$01E0
DC.W $01C5,$01AC,$0194,$017D,$0168,$0153,$0140,$012E,$011D,$010D,$00FE
DC.W $00F0,$00E2,$00D6,$00CA,$00BE,$00B4,$00AA,$00A0,$0097,$008F,$0087
DC.W $007F,$0078,$0071,$0000,$0000

MT_SPEED:	DC.B	$6
MT_SONGPOS:	DC.B	$0
MT_PATTPOS:	DC.W	$0
MT_COUNTER:	DC.B	$0

MT_BREAK:	DC.B	$0
MT_DMACON:	DC.W	$0
MT_SAMPLESTARTS:BLK.L	$1F,0
MT_VOICE1:	BLK.W	10,0
		DC.W	$1
		BLK.W	3,0
MT_VOICE2:	BLK.W	10,0
		DC.W	$2
		BLK.W	3,0
MT_VOICE3:	BLK.W	10,0
		DC.W	$4
		BLK.W	3,0
MT_VOICE4:	BLK.W	10,0
		DC.W	$8
		BLK.W	3,0


;---------------------------------------------------------------
;---------------------------------------------------------------
;---------------------------------------------------------------
;---------------------------------------------------------------
;---------------------------------------------------------------
;---------------------------------------------------------------
save_all:
move.L 4,a6
jsr -132(a6)
move.b #%10000111,$bfd100
move.l $6c,save_vecteur_irq
move.w $dff01c,save_intena
or.w #$c000,save_intena
move.w $dff002,save_dmacon
or.w #$8100,save_dmacon
rts
restore_all:
move.l save_vecteur_irq,$6c
move.w #$7fff,$dff09a
move.w save_intena,$dff09a
move.w #$7fff,$dff096
move.w save_dmacon,$dff096
move.l 4,a6
lea name_glib,a1
MOVEQ #0,D0
JSR -552(A6)
MOVE.L D0,A0
MOVE.L 38(A0),$DFF080
CLR.W $DFF088
MOVE.L 4,A6
JSR -138(A6)
RTS
SAVE_INTENA:DC.W 0
SAVE_DMACON:DC.W 0
save_vecteur_irq:dc.l 0
name_glib:dc.b "graphics.library",0
even

RALENTI:DC.W	3

make_fondu_1:
	subq.w	#1,ralenti
	bne.s	make

	move.w	#2,ralenti
	lea	COL+2(pc),a1

	moveq	#0,d0
	moveq	#31,d2
lp_fondu_col_BLEU:
	move.w	(a1),d1
	and.w	#$00f,d1
	cmpi.w	#$1,d1
	beq.s	red1_1
	sub.w	#$001,(a1)
	addq	#1,d0
red1_1:	move.w	(a1),d1
	and.w	#$0f0,d1
	tst.w	d1
	beq.s	gre1_2
	sub.w	#$010,(a1)
	addq	#1,d0
gre1_2:	move.w	(a1),d1
	and.w	#$f00,d1
	tst.w	d1
	beq.s	blu1_3
	sub.w	#$100,(a1)
	addq	#1,d0
blu1_3:	lea	4(a1),a1
	dbra	d2,lp_fondu_col_BLEU

	tst.w	d0
	bne.s	MAKE
	CLR.W	FOND1
	move.w	#2,fond2
make:	rts

make_fondu_2:
	subq.w	#1,ralenti
	bne.s	make

	move.w	#5,ralenti

	lea	PAL,a0
	lea	COL+2(pc),a1

	moveq	#31,d2
	moveq	#0,d3

lp_fondu_BLEU_col:
	move.w	(a0),d0
	and.w	#$00f,d0
	move.w	(a1),d1
	and.w	#$00f,d1
	cmp.w	d0,d1
	beq.s	red2_1
	add.w	#$001,(a1)
	addq	#1,d3
red2_1:	move.w	(a0),d0
	and.w	#$0f0,d0
	move.w	(a1),d1
	and.w	#$0f0,d1
	cmp.w	d0,d1
	beq.s	gre2_2
	add.w	#$010,(a1)
	addq	#1,d3
gre2_2:	move.w	(a0),d0
	and.w	#$f00,d0
	move.w	(a1),d1
	and.w	#$f00,d1
	cmp.w	d0,d1
	beq.s	blu2_3
	add.w	#$100,(a1)
	addq	#1,d3
blu2_3:	lea	2(a0),a0
	lea	4(a1),a1
	dbra	d2,lp_fondu_BLEU_col

	tst.w	d3
	bne.s	MAKE2
	CLR.L	FOND1
make2:	rts


PAL:	DC.W	$0000,$0FFF,$0BCF,$07AF,$037F,$025D,$014B,$013A
	DC.W	$0018,$0005,$0E9C,$0C6A,$0A48,$0826,$0614,$0211
	DC.W	$0322,$0544,$0766,$0988,$0389,$05BA,$08DB,$0BEC
	DC.W	$0433,$0655,$0877,$0A99,$053C,$085D,$0D8F,$0EBF

COPPERLIST1:
	DC.L	$01080000,$010A0000,$00960020,$01000200
	DC.L	$009400D0,$00920038
	DC.L	$009039D1,$008E0264

	DC.L	$1801FFFE
COL:	
	DC.L	$01800000,$01820000,$01840000,$01860000,$01880000
	DC.L	$018A0000,$018C0000,$018E0000
	DC.L	$01900000,$01920000,$01940000,$01960000,$01980000
	DC.L	$019A0000,$019C0000,$019E0000	
	DC.L	$01A00000,$01A20000,$01A40000,$01A60000,$01A80000
	DC.L	$01AA0000,$01AC0000,$01AE0000		
	DC.L	$01B00000,$01B20000,$01B40000,$01B60000,$01B80000
	DC.L	$01BA0000,$01BC0000,$01BE0000

	DC.L	$2501FFFE,$01005200
P1:	DC.L	$00E00000,$00E20000
P2:	DC.L	$00E40000,$00E60000
P3:	DC.L	$00E80000,$00EA0000
P4:	DC.L	$00EC0000,$00EE0000
P5:	DC.L	$00F00000,$00F20000

	DC.L	$FFE1FFFE,$01000200

	DC.L	$009C8010
	DC.L 	-2				; FIN COP

COPPERLIST:
	DC.L 	$10FFFFE,$920030,$9400D8,$9683E0,$1000200
COPSPR:
	DC.L 	$1200000,$1220000,$1240000,$1260000,$1280000,$12A0000
	DC.L 	$12C0000,$12E0000,$1300000,$1320000,$1340000,$1360000
	DC.L	$1380000
	DC.L 	$13A0000,$13C0000,$13E0000
	DC.L 	$01020000,$01040000

	DC.W	$0180,$0000 ,$0182,$0ECA ,$0184,$035E ,$0186,$023A
	DC.W	$0188,$0126 ,$018A,$0CC0 ,$018C,$0C80 ,$018E,$0C50
	DC.W	$01A0,$0000 ,$01A2,$099A ,$01A4,$0778 ,$01A6,$0334
	DC.W	$01A8,$0000 ,$01AA,$0667 ,$01AC,$0445 ,$01AE,$0223
	DC.W	$01B0,$0000 ,$01B2,$0FFF ,$01B4,$0AAA ,$01B6,$0666
	DC.W	$0190,$0000 ,$0192,$0E11 ,$0194,$0C12 ,$0196,$0B23
	DC.W	$0198,$0923 ,$019A,$0723 ,$019C,$0622 ,$019E,$0412

	DC.L 	$1B80000,$1BA0000,$1BC0000,$1BE0000
	
;	MOVE.L	#$026439D1,$8E(A6)
;	MOVE.L	#$003800D0,$92(A6)

	DC.L 	$2001FFFE,$9683E0
	DC.L	$01080000,$010A0000

	DC.L	$009400D0,$00920038
	DC.L	$009039D1,$008E0264

COPSCR1:DC.L 	$3D0FFFFE
	DC.L 	$400FFFFE,$1800002
	DC.L 	$410FFFFE,$1800004
	DC.L 	$420FFFFE,$1800007
	DC.L 	$430FFFFE,$1800004
	DC.L 	$440FFFFE,$1800002
	DC.L 	$44DFFFFE,$1800000,$450FFFFE

	DC.L	$00E00006,$00E22000,$01001200,$1820F99

	DC.L	$7FE1FFFE,$01820F88
	DC.L	$9FE1FFFE,$01820F77
	DC.L	$CDE1FFFE,$01820F66

;	MOVE.L #$3C791CC9,$8E(A6)
;	MOVE.L #$3000D8,$92(A6)

;	DC.L	$009400D8,$00920030

	DC.L 	$FFE1FFFE

	DC.L 	$160FFFFE,$960020,$01001200
	DC.L 	$00E00006,$00E20002
	DC.L	$01080004,$010A0004
;	DC.L 	$170FFFFE,$1001200
BAR1:	DC.L 	$1800002,$1820FFF
	DC.L 	$170FFFFE
BAR2:	DC.L 	$1800004,$1820EEE
	DC.L 	$180FFFFE
BAR3:	DC.L 	$1800007,$1820DDD
	DC.L 	$190FFFFE
BAR4:	DC.L 	$1800004,$1820CCC
	DC.L 	$1A0FFFFE
BAR5:	DC.L 	$1800002,$1820BBB

DC.L $1B0FFFFE
DC.L $1000200,$1800000
DC.L	$009C8010
DC.L -2				; FIN COP
FONT:	BLK.B	768
PIC:	BLK.B	10240*5
END:
MT_DATA=END
FIN=END+169182

>EXTERN	"METALLION.FNT04",FONT
>EXTERN "MOD.SUBSTANCE",MT_DATA
>EXTERN	"QTX.BT",PIC
